import os
import subprocess

tightnesses = [0.20, 0.30, 0.40]

RANDOM_SEED = 47
FILE_SUFFIX = '.xcsp'
DESIRED_SUFFIX = '.xml'
DO_SUPPORTS = True
INSTANCES_DESIRED = 30
INSTANCE_DIGITS = 2

variables = 30
density = 0.30
domain_size = 15

constraints = int(density * ((variables * (variables - 1)) / 2))
total_tuples = domain_size * domain_size
support_argument = ''
if DO_SUPPORTS:
    support_argument = '-s'

for tight in tightnesses:
    tuples_to_create = int(total_tuples * tight)
    if DO_SUPPORTS:
        tuples_to_create = int(total_tuples - (total_tuples * tight))

    name = ('results/v%d_d%d_c%d_t%d_' % 
            (variables, domain_size, constraints, tight * 100))
    
    command = [
        './a.out', 
        str(variables), str(domain_size), str(constraints),
        str(tuples_to_create), str(RANDOM_SEED), 
        str(INSTANCES_DESIRED), support_argument, '-f', name]
    subprocess.call(command)

    for old_count in range(0, INSTANCES_DESIRED)[::-1]:
        os.rename('%s%d%s' % (name, old_count, FILE_SUFFIX),
                  '%s%s%s' % (name, str(old_count+1).zfill(INSTANCE_DIGITS), DESIRED_SUFFIX))
    
